C 1997/9
C                FINITE ELEMENT METHOD
C          FOR TWO DIMENSIONAL ELASTIC ANALYSIS
C            ------- F2D6000 FOR WINDOUWS95 -------
C           USING 8 NODE ISOPARAMETRIC ELEMENT 
C                   BY TAKAYUKI HIRAI 
C
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/A/H22(2,8),XY(16),GZ,EA,BMA(3,16),DF(16),
     1         EE(3,3,300),XGX(5),WGX(5),BML(3,4),DET,
     2         UU(4),H(2,8,5,5),LX,LY,IRR,NONC,NGA,M,
     3         MZ(2700)
      COMMON/B/TLA(4,16),TLL(4,8),TAL(16,4),TTT(16,4),
     1         DB(3,16),SSP(16),SSU(16)
      COMMON/C/B(16000),DU(16000),AX(16000),PND(16000),
     1         FU(16000),DQ(16000),NC(16000),JH(16000),
     2         KG(16000),IA(16000),IB(16000),ID(16000),
     3         NQ(16000),KQ(16000)
      COMMON/D/SSG(2700),KR(21600),KH(21600),KH8(2700,8),
     1         IKH(8000),IKI(8000),AX8(8000,2)
      COMMON/E/EN(300),PR(300),TH(300),IP(300)
      COMMON/F/GX(30000),GG(6500000),GQ(6500000)
      CHARACTER TITLE*40
C
C  ---------------  INPUT DATA  ---------------
      KNVOL=6500000
      KNELE=2700
      KNODE=6000
      KNMAT=300
      KK88=30000
      IRR=0
      OPEN(15,FILE='DD')
      OPEN(16,FILE='R1')
      READ(15,1001) TITLE 
      WRITE(16,2002) TITLE 
      WRITE(*,2008) TITLE
 2008 FORMAT(//'  START MODEL =',A40)
      READ(15,1002) NELE,NODE8,NODT,NMAT,NGA,NONC
      WRITE(16,2003) NELE,NODE8,NODT,NMAT,NGA,NONC
      IF(NONC.NE.0) NONC=1
      IF(NELE*(KNELE-NELE+1).LE.0) IRR=20000
      IF(NODT*(KNODE-NODT+1).LE.0) IRR=30000
      IF(NMAT*(KNMAT-NMAT+1).LE.0) IRR=10000
      IF((NGA-2)*(6-NGA).LE.0.0) IRR=15000
      IF(IRR.NE.0) GO TO 403
      NODE=NODT
      NODE2=2*NODE
      READ(15,1001) TITLE
      DO 19 I=1,NODE
   19 READ(15,1003) N,AX8(I,1),AX8(I,2)
      READ(15,1001) TITLE
      DO 10 I=1,NELE
      READ(15,1004) N,(KH8(I,J),J=1,8),MZ(I),SSG(I)
      DO 12 J=1,7
      JJ=J+1
      DO 12 K=JJ,8
   12 IF(KH8(I,J).EQ.KH8(I,K)) IRR=40000+I     
   10 CONTINUE
      DO 22 I=1,4
      IKI(KH8(1,I))=I
   22 IKH(I)=KH8(1,I)
      I8=4
      DO 20 I=1,NELE
      DO 20 J=1,4
      DO 21 K=1,I8
   21 IF(KH8(I,J).EQ.IKH(K)) GO TO 20
      I8=I8+1
      IKH(I8)=KH8(I,J)
      IKI(KH8(I,J))=I8
   20 CONTINUE
      DO 23 I=1,NELE
      DO 23 J=5,8
      DO 24 K=1,I8
   24 IF(KH8(I,J).EQ.IKH(K)) GO TO 23
      I8=I8+1
      IKH(I8)=KH8(I,J)
      IKI(KH8(I,J))=I8
   23 CONTINUE
      IF(I8.NE.NODT) IRR=50000
      DO 25 I=1,NELE
      DO 25 J=1,8
   25 KH(I*8-8+J)=IKI(KH8(I,J))
      DO 26 I=1,NODE
      AX(I*2-1)=AX8(IKH(I),1)
   26 AX(I*2)=AX8(IKH(I),2)
      READ(15,1001) TITLE
      WRITE(16,2006)
      DO 11 I=1,NMAT
      READ(15,1005) N,EN(I),PR(I),TH(I),IP(I)
      WRITE(16,2007) I,EN(I),PR(I),TH(I),IP(I)
      IF(IP(I).EQ.1) EN(I)=EN(I)/(1.0-PR(I)**2)
      IF(IP(I).EQ.1) PR(I)=PR(I)/(1.0-PR(I))
      IF(DABS(PR(I)**2-1.0).LT.0.0001) IRR=11000+I
      IF(IRR.NE.0) GO TO 403
      DO 13 J=1,2
      EE(3,J,I)=0.0
      EE(J,3,I)=0.0
   13 EE(J,J,I)=EN(I)/(1.0-PR(I)*PR(I))
      EE(1,2,I)=EN(I)*PR(I)/(1.0-PR(I)*PR(I))
      EE(2,1,I)=EE(1,2,I)
   11 EE(3,3,I)=EN(I)/(1.0+PR(I))/2.0
      DO 15 I=1,NODE
      DO 15 J=1,2
      NC(I*2-2+J)=0
      DU(I*2-2+J)=0.0
   15 FU(I*2-2+J)=0.0
      READ(15,1001) TITLE
   16 READ(15,1006,END=18) N3,N1,N2,C1,C2
      IF(N3.GE.90000) GO TO 18 
      N=IKI(N3)
      NC(N*2-1)=N1
      NC(N*2)=N2
      IF(N1.EQ.1) DU(N*2-1)=C1
      IF(N2.EQ.1) DU(N*2)=C2
      IF(N1.EQ.0) FU(N*2-1)=C1
      IF(N2.EQ.0) FU(N*2)=C2
      GO TO 16
   18 CLOSE(15,STATUS='KEEP')
 1001 FORMAT(15X,A40) 
 1002 FORMAT(15X,I5)
 1003 FORMAT(I5,2F15.6)
 1004 FORMAT(10I5,F10.7)
 1005 FORMAT(I5,3F15.1,I5)
 1006 FORMAT(3I5,2F15.6)
 2002 FORMAT(//' ',10X,'FINITE ELEMENT METHOD USING ',
     1   'QUADRANGLE ISOPARAMETORC ELEMENT FOR TWO D',
     2   'IMENSIONAL ELASTIC ANALYSIS'/' ',27X,'----',
     3   '-- F2D6000 ------    8 NODES FOR SHAPE AND',
     4   ' DISPLACEMENT FUNCTION'/' ',32X,'BY TAKAYU',
     5   'KI HIRAI',13X,'CONFORMAL/NONCONFORMAL COND',
     6   'ITION'//'  MODEL TITLE    = ',A40)
 2003 FORMAT(//'  ELEMENTS =',I5,'          VERTEX N',
     1   'ODES =',I5,'    TOTAL NODES =',I5,'    MAT',
     2   'ERIALS =',I3,'    GAUSS POINTS =',I3/'    ',
     3   '     NONC (NONCONFORMAL = 0 ; CONFORMAL =',
     4   ' 1)  =',I5)
 2006 FORMAT(/' MATERIAL NO.   YOUNG''S RATIO    ',
     1   'POISSON''S RATIO    THICKNESS    ',
     2   'PLANESTRESS=0,PLANESTRAIN=1')
 2007 FORMAT(1H ,I9,F18.4,F15.6,F18.6,I18)
C
C  ------------  FORM CONECTION TABLE  ------------
      ID(1)=1
      I2=1
      DO 102 J=1,NODE
      I3=NODE
      DO 101 M=1,NELE
      DO 104 I=1,8
  104 IF(ID(J).EQ.KH(M*8-8+I)) GO TO 106
      GO TO 101
  106 DO 107 I=1,8
      DO 105 K=1,I2
  105 IF(ID(K).EQ.KH(M*8-8+I)) GO TO 115
      I2=I2+1
      ID(I2)=KH(M*8-8+I)
      GO TO 107
  115 IF(K.LT.I3) I3=K
  107 CONTINUE
  101 CONTINUE
      IB(J)=I2
      IA(J)=I3
      IF(IA(J).GT.J) IRR=50000
      IF(IB(J).LT.J) IRR=50000
  102 CONTINUE
      DO 108 I=2,NODE
      II=I
      DO 108 J=II,NODE
  108 IF(ID(I-1).EQ.ID(J)) IRR=50000
      IF(I2.NE.NODE) IRR=50000
      JH(1)=1
      DO 121 I=1,NODE
      DO 121 J=1,2
      I3=I*2-2+J
      KG(I3)=(IB(I)-I)*2+3-J
  121 IF(I3.GT.1) JH(I3)=JH(I3-1)+KG(I3-1)
      J7=JH(NODE2)+KG(NODE2)-1
      IF(J7.GT.KNVOL) IRR=60000
      IF(IRR.NE.0) GO TO 403
C 
C  ---------  CALCULATE STIFFNESS MATRIX  -----------
      DO 251 I=1,NODE2
  251 PND(I)=0.0 
      IF(NGA.EQ.4) GO TO 222
      IF(NGA.EQ.5) GO TO 223
      XGX(1)=-0.7745967
      XGX(2)=0.0
      XGX(3)=-XGX(1)
      WGX(1)=0.5555556
      WGX(2)=0.8888889
      WGX(3)=WGX(1)
      GO TO 224
  222 XGX(1)=-0.8611363
      XGX(2)=-0.3399810
      XGX(3)=-XGX(2)
      XGX(4)=-XGX(1)
      WGX(1)=0.3478548
      WGX(2)=0.6521452              
      WGX(3)=WGX(2)
      WGX(4)=WGX(1)
      GO TO 224
  223 XGX(1)=-0.9061798             
      XGX(2)=-0.5384693
      XGX(3)=0.0
      XGX(4)=-XGX(2)
      XGX(5)=-XGX(1)
      WGX(1)=0.2369269
      WGX(2)=0.4786287
      WGX(3)=0.5688889
      WGX(4)=WGX(2)
      WGX(5)=WGX(1)
  224 DO 202 LX=1,NGA
      GZ=XGX(LX)
      DO 202 LY=1,NGA
      EA=XGX(LY)
      CALL GGG
      DO 202 II=1,8
      DO 202 JJ=1,2
  202 H(JJ,II,LX,LY)=H22(JJ,II)
      WRITE(16,2202)
      DO 234 I=1,J7
  234 GQ(I)=0.0
      DO 211 M=1,NELE
      WRITE(*,2208) NELE,M
 2208 FORMAT('CALCULATING STIFFNESS MATRIX  ELEMENT NO.='
     1   I8,' -',I6)
      SVOL=0.0
      THH=TH(MZ(M))
      DO 212 II=1,8
      DO 212 JJ=1,2
  212 XY(II*2-2+JJ)=AX(KH(M*8-8+II)*2-2+JJ)
      DO 215 I=1,256
  215 GX(I)=0.0  
      IF(NONC.NE.0) GO TO 225
      DO 261 I=1,4
      DO 262 J=1,8
  262 TLL(I,J)=0.0
      DO 261 J=1,16
      TAL(J,I)=0.0
  261 TLA(I,J)=0.0
  225 DO 216 LX=1,NGA
      GZ=XGX(LX)
      DO 216 LY=1,NGA
      EA=XGX(LY)
      WT=WGX(LX)*WGX(LY)
      CALL FFF
      IF(IRR.NE.0) GO TO 403
      DO 217 I=1,3
      DO 217 J=1,16
      DB(I,J)=0.0
      DO 217 K=1,3
  217 DB(I,J)=DB(I,J)+EE(I,K,MZ(M))*BMA(K,J)
      VOL=WT*DET*THH
      IF(IRR.NE.0) GO TO 403 
      DO 218 I=1,16
      DO 218 J=1,16
      DO 218 K=1,3
  218 GX(I*16-16+J)=GX(I*16-16+J)+BMA(K,I)*DB(K,J)*VOL
      IF(NONC.NE.0) GO TO 201
      DO 263 I=1,4
      DO 263 J=1,16
      DO 263 K=1,3
  263 TLA(I,J)=TLA(I,J)+BML(K,I)*DB(K,J)*VOL
      DO 264 I=1,3
      DO 264 J=1,4
      DB(I,J)=0.0
      DO 264 K=1,3
  264 DB(I,J)=DB(I,J)+EE(I,K,MZ(M))*BML(K,J)
      DO 265 J=1,4
      DO 266 I=1,4
      DO 266 K=1,3
  266 TLL(I,J)=TLL(I,J)+BML(K,I)*DB(K,J)*VOL
      DO 265 I=1,16
      DO 265 K=1,3
  265 TAL(I,J)=TAL(I,J)+BMA(K,I)*DB(K,J)*VOL
  201 CONTINUE
  216 SVOL=SVOL+VOL
      IF(NONC.NE.0) GO TO 205
      DO 267 I=1,4
  267 TLL(I,I+4)=1.0
      DO 268 I=1,4
      IF(DABS(TLL(I,I)).LT.0.0001) IRR=40000+M
      IF(IRR.NE.0) GO TO 403
      II=I+1
      DO 268 J=II,8
      TLL(I,J)=TLL(I,J)/TLL(I,I)
      DO 268 K=1,4
      IF(K.EQ.I) GO TO 268
      TLL(K,J)=TLL(K,J)-TLL(K,I)*TLL(I,J)
  268 CONTINUE
      DO 271 I=1,16
      DO 271 J=1,4
      TTT(I,J)=0.0
      DO 271 K=1,4
  271 TTT(I,J)=TTT(I,J)+TAL(I,K)*TLL(K,J+4)
      DO 272 I=1,16
      DO 272 J=1,16
      DO 272 K=1,4
  272 GX(I*16-16+J)=GX(I*16-16+J)-TTT(I,K)*TLA(K,J)
  205 AREA=SVOL/THH
      WRITE(16,2204) M,(KH8(M,I),I=1,8),MZ(M),
     1   SSG(M),AREA,SVOL
      DO 252 I=1,16
  252 SSU(I)=SSG(M)*XY(I)
      DO 253 I=1,16
      SSP(I)=0.0
      DO 253 L=1,16
  253 SSP(I)=SSP(I)+GX(I*16-16+L)*SSU(L)
      DO 231 I=1,8
      DO 232 L=1,NODE
  232 IF(ID(L).EQ.KH(M*8-8+I)) GO TO 235
      IRR=50000
      GO TO 403 
  235 KB=IB(L)
      PND(ID(L)*2-1)=PND(ID(L)*2-1)+SSP(I*2-1)
      PND(ID(L)*2)=PND(ID(L)*2)+SSP(I*2)
      DO 231 J=1,8 
      DO 236 K=L,KB
  236 IF(KH(M*8-8+J).EQ.ID(K)) GO TO 237
      GO TO 231
  237 L2=L*2
      I2=I*2
      J2=J*2
      IF(K.EQ.L) GO TO 238
      DO 233 II=1,2
      DO 233 JJ=1,2
  233 GQ(JH(L2-2+II)-II+(K-L)*2+JJ)=GQ(JH(L2-2+II)-
     1   II+(K-L)*2+JJ)+GX((I2-3+II)*16+J2-2+JJ)
      GO TO 231
  238 GQ(JH(L2-1))=GQ(JH(L2-1))+GX((I2-2)*16+J2-1)
      GQ(JH(L2-1)+1)=GQ(JH(L2-1)+1)+GX((I2-2)*16+J2)
      GQ(JH(L2))=GQ(JH(L2))+GX((I2-1)*16+J2)
  231 CONTINUE
  211 CONTINUE
 2202 FORMAT(/' ELEMENT   NODE NO.',33X,'MAT.  INI. ',
     1   'STRAIN      AREA         VOLUME')
 2204 FORMAT(I4,I9,7I5,I8,F12.7,2F14.5)
C
C  ---------  FORM SIMULTANEOUS EQUATIONS  ----------
      DO 308 I=1,NODE2
  308 FU(I)=FU(I)+PND(I)
      K88=0
      K9=0
      KR(1)=1
      DO 301 I2=1,NODE
      KA=IA(I2)
      KB=IB(I2)
      DO 301 I3=1,2
      IF(NC(ID(I2)*2-2+I3).EQ.1) GO TO 301
      K5=0
      K9=K9+1
      B(K9)=FU(ID(I2)*2-2+I3)
      DO 303 I4=KA,KB
      DO 303 I5=1,2
      IF(NC(ID(I4)*2-2+I5).EQ.1) GO TO 304
      IF(I4*2+I5.LT.I2*2+I3) GO TO 303
      K5=K5+1
      GX(K5)=GQ(JH(I2*2-2+I3)+I4*2+I5-I2*2-I3)
      GO TO 303
  304 I6=JH(I2*2-2+I3)+I4*2+I5-I2*2-I3
      IF(I4*3+I5.LT.I2*3+I3) I6=JH(I4*2-2+I5)+
     1   I2*2+I3-I4*2-I5
      B(K9)=B(K9)-DU(ID(I4)*2-2+I5)*GQ(I6)
  303 CONTINUE
      KQ(K9)=K5
      IF(K5.GT.K88) K88=K5
      IF(K9.GT.1) KR(K9)=KR(K9-1)+KQ(K9-1)
      DO 306 LL=1,K5
      L1=KR(K9)+LL-1
  306 GG(L1)=GX(LL)
  301 CONTINUE
      K7=KR(K9)+KQ(K9)-1
      IF(K88.GT.KK88) IRR=80000
      IF(IRR.NE.0) GO TO 403 
C
C  --------  SOLVE SIMULTANEOUS EQUATIONS  ----------
      DO 364 I=1,K9
  364 IF(DABS(GG(KR(I))).LT.0.00001) IRR=70000+I
      IF(IRR.NE.0) GO TO 403
      I2=KQ(1)
      DO 361 I=1,I2
  361 NQ(I)=1
      DO 362 I=2,K9
      I2=I+KQ(I-1)-1
      I3=I+KQ(I)-1
      IF(I3.LT.I2-1) IRR=50000
      IF(IRR.NE.0) GO TO 403
      IF(I3.EQ.I2-1) GO TO 362
      DO 363 J=I2,I3
  363 NQ(J)=I
  362 CONTINUE
      IF(DABS(GG(1)).LT.0.000001) IRR=70000
      IF(IRR.NE.0) GO TO 403
      DO 351 I=2,K9
      WRITE(*,2308) K9,I
 2308 FORMAT('SOVING SIMULTANEOUS EUATIONS  NO.='
     1   I7,' -',I6)
      I4=I-1
      I2=I+KQ(I)-1
      IF(DABS(GG(KR(I))).LT.0.000001) IRR=70000
      IF(IRR.NE.0) GO TO 403
      DO 351 J=I,I2
      I3=NQ(J)
      IF(I3.GT.I4) GO TO 351
      DO 352 K=I3,I4
      K3=KR(K)
      K1=K3+I-K
      K2=K3+J-K
      K4=KR(I)+J-I
  352 GG(K4)=GG(K4)-GG(K1)*GG(K2)/GG(K3)
  351 CONTINUE
      B(1)=B(1)/GG(1)
      DO 371 I=2,K9
      I2=NQ(I)
      I3=I-1
      IF(I2.GT.I3) GO TO 371
      DO 372 J=I2,I3
  372 B(I)=B(I)-B(J)*GG(KR(J)+I-J)
  371 B(I)=B(I)/GG(KR(I))
      I2=K9-1
      DO 373 I=1,I2
  373 B(I)=B(I)*GG(KR(I))
      DO 375 I=1,I2
      I3=K9-I
      I4=KR(I3)+1
      I5=I4+KQ(I3)-2
      IF(I4.GT.I5) GO TO 375
      DO 376 J=I4,I5
  376 B(I3)=B(I3)-GG(J)*B(J-I4+I3+1)
  375 B(I3)=B(I3)/GG(I4-1)
C
C  -------------  CALCULATE SOLUTION  ---------------
      K4=0
      DO 383 I=1,NODE
      DO 383 J=1,2
      IF(NC(ID(I)*2-2+J).EQ.1) GO TO 383
      K4=K4+1
      DU(ID(I)*2-2+J)=B(K4)
  383 CONTINUE
      DO 388 I=1,NODE
      DO 388 J=1,2
  388 B(I*2-2+J)=DU(ID(I)*2-2+J)
      DO 382 I=1,NODE2
  382 DQ(I)=0.0
      DO 384 I=1,NODE2
      I2=I+1
      I3=KG(I)+I-1
      DO 385 J=I2,I3
  385 DQ(J)=DQ(J)+GQ(JH(I)+J-I)*B(I)
      DO 386 J=I,I3
  386 DQ(I)=DQ(I)+GQ(JH(I)+J-I)*B(J)
  384 CONTINUE
      DO 389 I=1,NODE
      DO 389 J=1,2
  389 B(ID(I)*2-2+J)=DQ(I*2-2+J)
      FMAX=0.0
      RMAX=0.0
      DO 387 I=1,NODE
      DO 387 J=1,2
      I2=I*2-2+J
      IF(NC(I2).EQ.1) GO TO 387
      IF(DABS(FU(I2)).GT.FMAX) FMAX=DABS(FU(I2))
      IF(DABS(B(I2)-FU(I2)).GT.RMAX)
     1   RMAX=DABS(B(I2)-FU(I2))
  387 CONTINUE
      RESI=RMAX
      IF(FMAX.GT.0.00001) RESI=RMAX/FMAX
C
C  -----  OUTPUT NODAL FORCE AND DISPLACEMENT  ------ 
      WRITE(16,2402)
      DO 401 N3=1,NODE
      N=IKI(N3)
      B(N*2-1)=B(N*2-1)-PND(N*2-1)
      B(N*2)=B(N*2)-PND(N*2)
  401 WRITE(16,2403) N3,AX(N*2-1),AX(N*2),NC(N*2-1),
     1   NC(N*2),B(2*N-1),B(2*N),DU(N*2-1),DU(N*2)
 2402 FORMAT(/' NODE       CO-ORDINATE X-Y',13X,'B.C.'
     1   ,7X,'FORCE X-Y',19X,'DISPLACEMENT X-Y')
 2403 FORMAT(1H ,I5,2F15.6,I5,I2,2F16.6,2E16.7)
C
C  ------ CALCULATE NONCONFORMAL DISPLACEMENT ------
      IF(NONC.NE.0) GO TO 403
      WRITE(16,2411)      
      DO 411 M=1,NELE
      DO 412 II=1,8
      I3=KH(M*8-8+II)
      DF(2*II-1)=DU(I3*2-1)
      DF(2*II)=DU(2*I3)
      DO 412 JJ=1,2
  412 XY(JJ+II*2-2)=AX(I3*2-2+JJ)
      CALL UUU
      IF(IRR.NE.0) GO TO 403
  411 WRITE(16,2412) M,(UU(I),I=1,4)
  403 WRITE(16,2404) IRR,K88,J7,K7,K9,RMAX,FMAX,RESI
C
C  ------ CALCULATE FORCE BALAMCE ------
      IF(IRR.NE.0) GO TO 425
      SXT1=0.0
      SXT2=0.0
      SYT1=0.0
      SYT2=0.0
      REXS=0.0
      REYS=0.0
      DO 420 I=1,NODE
      IF(B(I*2-1).GE.0.0) SXT1=SXT1+B(I*2-1)
      IF(B(I*2-1).LT.0.0) SXT2=SXT2+B(I*2-1)
      IF(B(I*2).GE.0.0) SYT1=SYT1+B(I*2)
  420 IF(B(I*2).LT.0.0) SYT2=SYT2+B(I*2)
      RXTS=SXT1+SXT2
      RYTS=SYT1+SYT2
      ARXTS=DABS(RXTS)
      ARYTS=DABS(RYTS)
      PXT1=DABS(SXT1)
      PXT2=DABS(SXT2)
      PYT1=DABS(SYT1)
      PYT2=DABS(SYT2)
      IF (PXT1.LT.PXT2) PXT1=PXT2
      IF (PYT1.LT.PYT2) PYT1=PYT2
      IF(PXT1.GT.0.0001) GO TO 421
      XPA=9999.999  
      IF(ARXTS.LT.0.0005) XPA=0.0
      GO TO 422
  421 XPA=ARXTS/PXT1
  422 IF(PYT1.GT.0.0001) GO TO 423
      YPA=9999.999  
      IF(ARYTS.LT.0.0005) YPA=0.0
      GO TO 424
  423 YPA=ARYTS/PYT1
  424 WRITE(16,2421) SXT1,SXT2,RXTS,XPA,SYT1,SYT2,RYTS,YPA
  425 CLOSE(16,STATUS='KEEP')
 2421 FORMAT(//'  FORCE BALANCE    + NODAL FORCE   - '
     1   ,'NODAL FORCE   RESIDUAL FORCE     RES.F./NOD.F.'
     2   /'  X DIRECTION   ',F15.3,2F17.3,F18.5,
     3   /'  Y DIRECTION   ',F15.3,2F17.3,F18.5)
 2404 FORMAT(//' IRR =',I6,5X,'MAXIMUM LENGTH OF EQUA'
     1   ,'TION',14X,'=',I8/' ',16X,'HALF VOLUME OF W'
     2   ,'HOLE COEFFICIENT MATRIX =',I8/' ',16X,'HAL'
     3   ,'F VOLUME OF S. E. COEFFICIENT MATRIX =',I8/
     4   ' ',16X,'NUMBER OF UNKNOWNS IN S. E.',13X,'='
     5   ,I8/' ',16X,'RESIDUAL IN SOLUTION'/' ',26X,
     6   'RESIDUAL NORM =',F15.7/' ',26X,'FORCE NORM',
     7   '    =',F15.7/' ',26X,'RES.N./FOR.N. =',E15.6)
 2411 FORMAT(/' NONCONFORMAL DISPLACEMENT ON EACH ELE',
     1   'MENT'/'  ELEMENT      X9          X10      ',
     2   '     Y9          Y10')
 2412 FORMAT(1H ,I5,4E14.6)
      STOP
      END
      SUBROUTINE GGG
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/A/H22(2,8),XY(16),GZ,EA,BMA(3,16),DF(16),
     1         EE(3,3,300),XGX(5),WGX(5),BML(3,4),DET,
     2         UU(4),H(2,8,5,5),LX,LY,IRR,NONC,NGA,M,
     3         MZ(2700)
      GZP=1.0+GZ
      EAP=1.0+EA
      GZM=1.0-GZ
      EAM=1.0-EA
      GZ2=1.0-GZ*GZ
      EA2=1.0-EA*EA
      H22(1,1)=EAM*(2.0*GZ+EA)/4.0
      H22(1,2)=EAM*(2.0*GZ-EA)/4.0
      H22(1,3)=EAP*(2.0*GZ+EA)/4.0
      H22(1,4)=EAP*(2.0*GZ-EA)/4.0
      H22(1,5)=-EAM*GZ
      H22(1,6)=EA2/2.0
      H22(1,7)=-EAP*GZ
      H22(1,8)=-EA2/2.0
      H22(2,1)=GZM*(2.0*EA+GZ)/4.0
      H22(2,2)=GZP*(2.0*EA-GZ)/4.0
      H22(2,3)=GZP*(2.0*EA+GZ)/4.0
      H22(2,4)=GZM*(2.0*EA-GZ)/4.0
      H22(2,5)=-GZ2/2.0
      H22(2,6)=-GZP*EA
      H22(2,7)=GZ2/2.0
      H22(2,8)=-GZM*EA
      RETURN
      END
      SUBROUTINE FFF
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/A/H22(2,8),XY(16),GZ,EA,BMA(3,16),DF(16),
     1         EE(3,3,300),XGX(5),WGX(5),BML(3,4),DET,
     2         UU(4),H(2,8,5,5),LX,LY,IRR,NONC,NGA,M,
     3         MZ(2700)
      DIMENSION GJI(2,2),GH(2,8),GJ(2,2)
      DO 500 I=1,2
      DO 500 J=1,2
      GJ(I,J)=0.0
      DO 500 K=1,8
  500 GJ(I,J)=GJ(I,J)+H(I,K,LX,LY)*XY(K*2-2+J)
      DET=GJ(1,1)*GJ(2,2)-GJ(1,2)*GJ(2,1)
      IF(DABS(DET).GT.1.E-09) GO TO 501
      IRR=40000+M
      RETURN 
  501 GJI(1,1)=GJ(2,2)/DET
      GJI(2,1)=-GJ(2,1)/DET
      GJI(1,2)=-GJ(1,2)/DET
      GJI(2,2)=GJ(1,1)/DET
      DO 502 I=1,8
      DO 502 J=1,2
      GH(J,I)=0.0
      DO 502 K=1,2
  502 GH(J,I)=GH(J,I)+GJI(J,K)*H(K,I,LX,LY)
      DO 503 I=1,3
      DO 503 J=1,16
  503 BMA(I,J)=0.0
      DO 504 J=1,8
      BMA(1,2*J-1)=GH(1,J)
      BMA(2,2*J)  =GH(2,J)
      BMA(3,2*J-1)=GH(2,J)
  504 BMA(3,2*J)  =GH(1,J)
      IF(NONC.NE.0) RETURN
      DO 506 I=1,2
      GH(I,1)=GJI(I,1)*(1.0-3.0*GZ*GZ)
  506 GH(I,2)=GJI(I,2)*(1.0-3.0*EA*EA)
      DO 505 I=1,3
      DO 505 J=1,4
  505 BML(I,J)=0.0
      DO 507 J=1,2
      BML(1,J)  =GH(1,J)
      BML(2,J+2)=GH(2,J)
      BML(3,J)  =GH(2,J)
  507 BML(3,J+2)=GH(1,J)
      RETURN
      END
      SUBROUTINE UUU
      IMPLICIT REAL*8(A-H,O-Z)
      COMMON/A/H22(2,8),XY(16),GZ,EA,BMA(3,16),DF(16),
     1         EE(3,3,300),XGX(5),WGX(5),BML(3,4),DET,
     2         UU(4),H(2,8,5,5),LX,LY,IRR,NONC,NGA,M,
     3         MZ(2700)
      DIMENSION TUU(4,16),TLL(4,8),TLA(4,16),DB(3,16)
      DO 261 I=1,4
      DO 226 J=1,8
  226 TLL(I,J)=0.0
      DO 261 J=1,16
  261 TLA(I,J)=0.0
  225 DO 216 LX=1,NGA
      GZ=XGX(LX)
      DO 216 LY=1,NGA
      EA=XGX(LY)
      WT=WGX(LX)*WGX(LY)
      CALL GGG
      CALL FFF
      IF(IRR.NE.0) RETURN
      DO 217 I=1,3
      DO 217 J=1,16
      DB(I,J)=0.0
      DO 217 K=1,3
  217 DB(I,J)=DB(I,J)+EE(I,K,MZ(M))*BMA(K,J)
      VOL=WT*DET
      DO 263 I=1,4
      DO 263 J=1,16
      DO 263 K=1,3
  263 TLA(I,J)=TLA(I,J)+BML(K,I)*DB(K,J)*VOL
      DO 264 I=1,3
      DO 264 J=1,4
      DB(I,J)=0.0
      DO 264 K=1,3
  264 DB(I,J)=DB(I,J)+EE(I,K,MZ(M))*BML(K,J)
      DO 266 J=1,4
      DO 266 I=1,4
      DO 266 K=1,3
  266 TLL(I,J)=TLL(I,J)+BML(K,I)*DB(K,J)*VOL
  216 CONTINUE
      DO 267 I=1,4
  267 TLL(I,I+4)=1.0
      DO 268 I=1,4
      IF(DABS(TLL(I,I)).LT.0.0001) IRR=40000+M
      IF(IRR.NE.0) RETURN
      II=I+1
      DO 268 J=II,8
      TLL(I,J)=TLL(I,J)/TLL(I,I)
      DO 268 K=1,4
      IF(K.EQ.I) GO TO 268
      TLL(K,J)=TLL(K,J)-TLL(K,I)*TLL(I,J)
  268 CONTINUE
      DO 271 I=1,4
      DO 271 J=1,16
      TUU(I,J)=0.0
      DO 271 K=1,4
  271 TUU(I,J)=TUU(I,J)+TLL(I,K+4)*TLA(K,J)
      DO 235 I=1,4
      UU(I)=0.0
      DO 235 J=1,16
  235 UU(I)=UU(I)-TUU(I,J)*DF(J)
      RETURN
      END
